"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const exportModel_1 = require("./exportModel");
const format_1 = require("./format");
const getModelNames_1 = require("./getModelNames");
/**
 * Generate Models using the Handlebar template and write to disk.
 * @param models Array of Models to write.
 * @param templates The loaded handlebar templates.
 * @param outputPath
 */
function writeClientModels(models, templates, outputPath) {
    models.forEach(model => {
        const file = path.resolve(outputPath, `${model.name}.ts`);
        const templateData = exportModel_1.exportModel(model);
        const templateResult = templates.model(templateData);
        fs.writeFileSync(file, format_1.format(templateResult));
    });
    const file = path.resolve(outputPath, 'index.ts');
    const templateResult = templates.models({
        models: getModelNames_1.getModelNames(models),
    });
    fs.writeFileSync(file, format_1.format(templateResult));
}
exports.writeClientModels = writeClientModels;
